import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ComputeAverageFilter extends EffectFilter
{	
	public ComputeAverageFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "Image Average " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage(1, 1, 1);
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Image Average"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Image In";
	}
	
	public String getOutputName(int outputNum)
	{
		return "DATA: Avg Brightness";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				int imgWidth = temp.getWidth();
				int imgHeight = temp.getHeight();
				
				double[][] ired = temp.getChannelData(0);
				double[][] igreen = temp.getChannelData(1);
				double[][] iblue = temp.getChannelData(2);
				
				double total = 0.0;
				
				for(int i = 0; i < imgWidth; ++i)
				{
					for(int j = 0; j < imgHeight; ++j)
					{
							total += ired[i][j];
							total += igreen[i][j];
							total += iblue[i][j];
					}
				}
				
				double average = (total / 3.0) / ((double)(imgWidth * imgHeight));
				
				double[][] internal = internalBuffer.getChannelData(0);
				internal[0][0] = average;
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}