import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class DisplayFilter extends EffectFilter
{
	private transient FloatImageScreen imgScreen;
	
	public DisplayFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "Display " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 100;
		guiY = 100;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		imgScreen = new FloatImageScreen();
		
		guiWindow.add(new JLabel("Display (hopefully)"));
		guiWindow.add(imgScreen);
		
		guiWindow.setVisible(true);
	}
	
	public BufferedImage getImage()
	{
		if(imgScreen != null)
			return imgScreen.getImage();
		else
			return null;
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "DisplayInput";
	}
	
	public String getOutputName(int outputNum)
	{
		return "NONE";
	}
	
	public int numInputs()
	{
		if(filterInputs != null)
			return filterInputs.length;
		else
			return 0;
	}
	
	public int numOutputs()
	{
		return 0;
	}
	
	public void update(long dt)
	{
		if(filterInputs != null && filterInputs[0] != null)
		{
			if(imgScreen != null)
				imgScreen.imgUpdate(filterInputs[0].getOutput());
		}
	}
}