import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import java.awt.event.*;

//import Draw.updater;

public class DrawRobot implements GenericRobot
{
	long lastTime;
	Draw drawer = new Draw();
	Thread drawThread;
	protected JFrame theFrame;
	
	protected static final double CONST_ADD = 5.0;
	protected static final double MULTIPLIER = 40.0;
	
	public void update(long dt, FilterLink[] inputs)
	{
		long curTime = System.currentTimeMillis();
		dt = curTime - lastTime;
		lastTime = curTime;
		
		if(dt < 0 || dt > 1000)
			dt = 20;
			
		// first, get the location and angle
		double curX = -1000.0;
		double curY = -1000.0;
		
		double curTheta = 0.0;
		
		if(inputs[0] != null)
		{
			FloatImage p1i = inputs[0].getOutput();
			
			if(p1i != null)
			{
				double p1x, p2x, p1y, p2y;
				double[][] temput = p1i.getChannelData(0);
				p1x = temput[0][0];
				p1y = temput[1][0];
				p2x = temput[0][1];
				p2y = temput[1][1];
				
				// we say the current position is the average of these two!
				curX = (p1x + p2x) / 2.0;
				curY = (p1y + p2y) / 2.0;
				
				// compute theta!
				// we have to offset by 90 degrees since the dots are perpendicular
				// to the direction the robot is actually facing...
				curTheta = Math.atan2(p2y - p1y, p2x - p1x) - (Math.PI / 2.0);
				while(curTheta < 0.0)
					curTheta += (Math.PI * 2.0);
			}
			else
			{
				return;
			}
		}
		else
		{
			return;
		}
		
		drawer.setPosition((curX + CONST_ADD) * MULTIPLIER, (curY + CONST_ADD) * MULTIPLIER, curTheta);
	}
	
	public void startRobot()
	{
		System.out.println("Starting robot!");
		
	    drawThread = new Thread(drawer);
	    drawThread.start();
	}
	
	public void init()
	{
		JFrame theFrame = new JFrame("Frame!");
		theFrame.setSize(300,300);
		
		JButton startButton = new JButton("Start Robot");
		startButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				startRobot();
			}
		});
		
		theFrame.getContentPane().add(startButton);
		theFrame.setVisible(true);
	}
}
