import java.io.*;
import java.util.*;

public class Drawing {
	public Vector<DrawPoint> points = new Vector<DrawPoint>();
	public int currentPointIndex = 0;
	
	public Drawing(String filename) {
		try {
			FileInputStream fstream = new FileInputStream(filename);
			DataInputStream in = new DataInputStream(fstream);
			
			Scanner s = new Scanner(in);

			while(s.hasNext()) {
				points.add(new DrawPoint(s.nextDouble(), s.nextDouble(), s.nextInt()));
			}
			in.close();
		} 
		catch (Exception e) {
			System.out.println(e);
			System.err.println("ERROR:  File input error in Drawing Loader");
		}
	}

	public DrawPoint getNextPoint() {
		return points.get(currentPointIndex++);
	}
	
	public boolean hasNextPoint() {
		return points.size() > currentPointIndex;
	}
}