import java.io.*;

public class FilterLink implements Serializable
{
	private EffectFilter sourceFilter;
	private EffectFilter destFilter;
	private int sourceOutput;
	private int destInput;
	
	public FilterLink(EffectFilter source, EffectFilter dest, int outputChannel, int inputChannel)
	{
		sourceFilter = source;
		destFilter = dest;
		sourceOutput = outputChannel;
		destInput = inputChannel;
	}
	
	public FloatImage getOutput()
	{
		if(sourceFilter != null)
			return sourceFilter.getOutput(sourceOutput);
		else
			return null;
	}
	
	public EffectFilter getDest()
	{
		return destFilter;
	}
	
	public int getDestChannel()
	{
		return destInput;
	}
	
	public EffectFilter getSource()
	{
		return sourceFilter;
	}
}