import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class HSVConversionFilter extends EffectFilter
{	
	public HSVConversionFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "HSV Conversion (min) " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("HSV Conversion"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input";
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null)
		{	
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{

				if(internalBuffer.getWidth() != temp.getWidth() ||
					internalBuffer.getHeight() != temp.getHeight())
				{
					internalBuffer = new FloatImage(3, temp.getWidth(), temp.getHeight());
				}
				
				double[][] curIn, curOut;
				
				// copy data to internal buffer
				for(int k = 0; k < 3; ++k)
				{
					curIn = temp.getChannelData(k);
					curOut = internalBuffer.getChannelData(k);	
					
					for(int j = 0; j < temp.getHeight(); ++j)
					{
						for(int i = 0; i < temp.getWidth(); ++i)
						{
							curOut[i][j] = curIn[i][j];
						}
					}
				}
				
				HSVUtils.RGBtoHSVinPlace(internalBuffer);
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}