public class LightFollower implements GenericRobot
{
	protected final static int MODE_ROTATE = 1;
	protected final static int MODE_REVERSE = 3;
	protected final static int MODE_FOLLOW =2;
	
	long lastTime;
	
	protected int mode;
	protected int rotateTime;
	
	public void update(long dt, FilterLink[] inputs)
	{
		RoombaControl theControl = RoombaControl.getInstance();
		
		long curTime = System.currentTimeMillis();
		dt = curTime - lastTime;
		lastTime = curTime;
		
		if(dt < 0 || dt > 1000)
			dt = 20;
			
		
		if(mode == MODE_FOLLOW)
		{
			double leftSide = 0.0;
			double rightSide = 0.0;
			
			double rightVel = 0.0;
			double leftVel = 0.0;
		
			if(inputs[0] != null)
				leftSide = inputs[0].getOutput().getChannelData(0)[0][0];
			if(inputs[1] != null)
				rightSide = inputs[1].getOutput().getChannelData(0)[0][0];
				
			if(leftSide > rightSide)
			{
				theControl.directDrive(0.3, 0.1);
				System.out.println("Left");
			}
			else
			{
				theControl.directDrive(0.1, 0.3);
				System.out.println("Right");
			}
				
			rightVel = 0.0 + ((leftSide + 1.0) * 0.2);
			leftVel = 0.0 + ((rightSide + 1.0) * 0.2);
			
			//theControl.directDrive(rightVel, leftVel);
				
			if(theControl.bumpLeft() || theControl.bumpRight())
			{
				System.out.println("Bump!");
				mode = MODE_REVERSE;
				rotateTime = 300;
				theControl.directDrive(-0.3, -0.3);
			}
		}
		else if(mode == MODE_REVERSE)
		{
			rotateTime -= dt;
			if(rotateTime <= 0)
			{
				System.out.println("Done reversing!");
				mode = MODE_ROTATE;
				rotateTime = (int)(Math.random() * 1000.0) + 1000;
				//if(Math.random() > 0.5)
				theControl.directDrive(-0.2, 0.2);
				//else
				//	theControl.directDrive(0.2, -0.2);
			}
		}
		else if(mode == MODE_ROTATE)
		{
			rotateTime -= dt;
			if(rotateTime <= 0)
			{
				System.out.println("Back to following!");
				mode = MODE_FOLLOW;
			}
		}
	}
	
	public void init()
	{
		RoombaControl theControl = RoombaControl.getInstance();
		
		theControl.startOI();
		theControl.setSafeMode();
		
		mode = MODE_FOLLOW;
		rotateTime = 0;
	}
}