import java.util.ArrayList;
import java.util.Scanner;
import java.io.FileInputStream;

public class LineSegmentLoader
{
	public static ArrayList<ImageLineSegment> loadSegments(String filename, double width)
	{
		// First, open up the file to load the source directory...
		Scanner src = null;
		
		try
		{
			src = new Scanner(new FileInputStream(filename));
		}
		catch(java.io.IOException e)
		{
			System.out.println("IOException: " + e);
		}
		
		if(src == null)
			return null;
			
		ArrayList<ImageLineSegment> segments = new ArrayList<ImageLineSegment>();
			
		while(src.hasNextInt())
		{
			ImageLineSegment curSegment = new ImageLineSegment();
			curSegment.x1 = (int)(((double)src.nextInt() / 400.0) * width);
			curSegment.y1 = (int)(((double)src.nextInt() / 400.0) * width);
			curSegment.x2 = (int)(((double)src.nextInt() / 400.0) * width);
			curSegment.y2 = (int)(((double)src.nextInt() / 400.0) * width);
			segments.add(curSegment);
		}
			
		src.close();
		
		return segments;
	}
}