public class Orientation{
	public double theta;
	public double x;
	public double y;
	
	public Orientation()
	{
		theta = 0.0;
		x = 0.0;
		y = 0.0;
	}
	
	public Orientation(double x, double y, double theta)
	{
		this.x = x;
		this.y = y;
		this.theta = theta;
	}
	
	public Orientation(double x1, double y1, double x2, double y2)
	{
		this.x = x1;
		this.y = y1;
		
		// Calculate the theta from the other point
		double dx = x2 - x1;
		// we flip this due to crazy coordinate system issues...
		double dy = y1 - y2;
		double adx = Math.abs(dx);
		double ady = Math.abs(dy);
		
		if(adx > ady)
			theta = Math.atan(ady / adx);
		else
			theta = Math.atan(adx / ady);
			
		// now modify theta depending upon sector
		if(dx >= 0.0 && dy >= 0.0)
			theta = theta;
		else if(dx < 0.0 && dy >= 0.0)
			theta = Math.PI - theta;
		else if(dx < 0.0 && dy < 0.0)
			theta = Math.PI + theta;
		else if(dx >= 0.0 && dy < 0.0)
			theta = (Math.PI * 2) - theta;
	}
}