import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PostIdentifyTestFilter extends EffectFilter
{	
	public PostIdentifyTestFilter()
	{
		filterInputs = new FilterLink[2];
		filterInputs[0] = null;
		filterInputs[1] = null;
		dead = false;
		filterName = "Post Identify Test " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Post Identify Test"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		if(inputNum == 0)
			return "SegmentedColorIn";
		else
			return "IntensityIn";
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null && filterInputs[1] != null)
		{	
			FloatImage temp = filterInputs[0].getOutput();
			FloatImage temp2 = filterInputs[1].getOutput();
			
			if(temp != null && temp2 != null)
			{

				if(internalBuffer.getWidth() != temp2.getWidth() ||
					internalBuffer.getHeight() != temp2.getHeight())
				{
					internalBuffer = new FloatImage(3, temp2.getWidth(), temp2.getHeight());
				}
				
				double[][] curIn, curOut;
				
				// copy data to internal buffer
				for(int k = 0; k < 3; ++k)
				{
					curIn = temp2.getChannelData(k);
					curOut = internalBuffer.getChannelData(k);	
					
					for(int j = 0; j < temp2.getHeight(); ++j)
					{
						for(int i = 0; i < temp2.getWidth(); ++i)
						{
							curOut[i][j] = curIn[i][j];
						}
					}
				}
				
				PostIdentifyUtils.findPosts(temp, temp2, internalBuffer);
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}