import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RandomColorFilter extends EffectFilter
{	
	public RandomColorFilter()
	{
		filterInputs = new FilterLink[2];
		filterInputs[1] = null;
		filterInputs[0] = null;
		dead = false;
		filterName = "Random Color " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Random Color"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		switch(inputNum)
		{
		case 0:
			return "Colors in";
		case 1:
			return "Size in";
		default:		
			return "Unknown Input";
		}
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null && filterInputs[1] != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			FloatImage temp2 = filterInputs[1].getOutput();
			
			if(temp != null && temp2 != null)
			{
				if(temp2.getWidth() != internalBuffer.getWidth() || temp2.getHeight() != internalBuffer.getHeight())
				{
					internalBuffer = new FloatImage(3, temp2.getWidth(), temp2.getHeight());	
				}
				
				int imgWidth = internalBuffer.getWidth();
				int imgHeight = internalBuffer.getHeight();
				
				double[][] ored = internalBuffer.getChannelData(0);
				double[][] ogreen = internalBuffer.getChannelData(1);
				double[][] oblue = internalBuffer.getChannelData(2);
				
				double[][] ired = temp.getChannelData(0);
				double[][] igreen = temp.getChannelData(1);
				double[][] iblue = temp.getChannelData(2);
				
				double min;
				
				double nr, ng, nb;
				
				int img2Width = temp.getWidth();
				int img2Height = temp.getHeight();
				
				int sx = (int)(Math.random() * img2Width);
				int sy = (int)(Math.random() * img2Height);
				
				nr = ired[sx][sy];
				ng = igreen[sx][sy];
				nb = iblue[sx][sy];
				
				for(int i = 0; i < imgWidth; ++i)
				{
					for(int j = 0; j < imgHeight; ++j)
					{
						ored[i][j] = nr;
						ogreen[i][j] = ng;
						oblue[i][j] = nb;
					}
				}
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}