import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class RobotPowerLightFilter extends EffectFilter
{	
	public RobotPowerLightFilter()
	{
		filterInputs = new FilterLink[2];
		filterInputs[0] = null;
		filterInputs[1] = null;
		dead = false;
		filterName = "Robot Power Light " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 100;
		guiY = 100;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{	
		internalBuffer = null;
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Robot Power Light"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		if(inputNum == 0)
			return "DATA: Color in";
		else
			return "DATA: Intensity in";
	}
	
	public String getOutputName(int outputNum)
	{
		return "NONE";
	}
	
	/*
	public int numInputs()
	{
		if(filterInputs != null)
			return filterInputs.length;
		else
			return 0;
	}
	
	public int numOutputs()
	{
		return 0;
	}
	*/
	
	public void update(long dt)
	{
		if(filterInputs != null && filterInputs[0] != null && filterInputs[1] != null)
		{
			RoombaControl theController = RoombaControl.getInstance();
			
			double color = filterInputs[0].getOutput().getChannelData(0)[0][0];
			double intensity = filterInputs[1].getOutput().getChannelData(0)[0][0];
			
			theController.setPowerLEDState((color + 1.0) / 2.0, (intensity + 1.0) / 2.0);
		}
	}
}