import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class RobotStubFilter extends EffectFilter
{
	protected transient GenericRobot robot;	

	public RobotStubFilter()
	{
		filterInputs = new FilterLink[5];
		for(int i = 0; i < filterInputs.length; ++i)
			filterInputs[i] = null;
			
		dead = false;
		robot = null;
		filterName = "Robot Control Stub " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 100;
		guiY = 100;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{	
		internalBuffer = null;
		needsProcessing = true;
		robot = RobotFactory.getDefaultRobot();
		robot.init();
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth, guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Robot Control Stub"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input " + inputNum;
	}
	
	public String getOutputName(int outputNum)
	{
		return "NONE";
	}
	
	public void update(long dt)
	{
		// As suggested by the title, this is just the barest bones stub for
		//  a robot controller
		
		if(robot != null)
		{
			robot.update(dt, filterInputs);
		}
	}
}