import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SimpleCyclerFilter extends EffectFilter
{
	private FloatImage cyclingColors;
	private FloatImage cyclingImage;
	private transient SimpleCycler theCycler;
		
	public SimpleCyclerFilter()
	{
		filterInputs = new FilterLink[3];
		filterInputs[0] = null;
		filterInputs[1] = null;
		filterInputs[2] = null;
		dead = false;
		filterName = "History/Cycling Effect " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
		cyclingImage = new FloatImage();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		cyclingColors = new FloatImage();
		theCycler = new SimpleCycler();
		theCycler.setCyclingField(cyclingImage);
		
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);

		JPanel foo = new JPanel();
		
		JButton colorsButton = new JButton("Capture Colors");
		colorsButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				// must be a button press
				doColorCapture();
			}
		});
		foo.add(colorsButton);
		
		JButton cyclingButton = new JButton("Capture Cycling");
		cyclingButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				// must be a button press
				doCyclingCapture();
			}
		});
		foo.add(cyclingButton);
		
		guiWindow.add(foo);
		
		guiWindow.setVisible(true);
	}
	
	public void doColorCapture()
	{
		if(filterInputs[2] != null)
		{
			FloatImage temp = filterInputs[2].getOutput();
			if(temp != null)
				cyclingColors = temp.duplicate();
		}
	}
	
	public void doCyclingCapture()
	{
		if(filterInputs[1] != null)
		{
			FloatImage temp = filterInputs[1].getOutput();
			if(temp != null)
			{
				cyclingImage = temp.duplicate();
				theCycler.setCyclingField(cyclingImage);
			}
		}
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		switch(inputNum)
		{
		case 0:
			return "HotSpot in";
		case 1:
			return "Cycling in";
		case 2:
			return "Colors in";
		default:
			return "input";
		}
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null && theCycler != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				double[][] red = temp.getChannelData(0);
				
				theCycler.setHotSpots(red);
				theCycler.updateCycling();
				internalBuffer = theCycler.getCyclingImage(cyclingColors);
			}
			
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}