import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UpscaleFilter extends EffectFilter
{	
	public UpscaleFilter()
	{
		filterInputs = new FilterLink[1];
		filterInputs[0] = null;
		dead = false;
		filterName = "Upscale " + (int)(Math.random() * 1000);
		
		guiWidth = 100;
		guiHeight = 100;
		guiX = 200;
		guiY = 200;
		
		rebuildFromSave();
	}
	
	public void rebuildFromSave()
	{
		internalBuffer = new FloatImage();
		needsProcessing = true;
		
		guiWindow = new JInternalFrame(filterName, true, true, true, true);
		guiWindow.setSize(guiWidth,guiHeight);
		guiWindow.setLocation(guiX, guiY);
		
		guiWindow.add(new JLabel("Upscale"));
		
		guiWindow.setVisible(true);
	}
	
	public String getName()
	{
		return filterName;
	}
	
	public String getInputName(int inputNum)
	{
		return "Input";
	}
	
	public String getOutputName(int outputNum)
	{
		return "Output";
	}
	
	public int numOutputs()
	{
		return 1;
	}
	
	public FloatImage getOutput(int outputChannel)
	{	
		if(needsProcessing && filterInputs[0] != null)
		{
			FloatImage temp = filterInputs[0].getOutput();
			
			if(temp != null)
			{
				int imgWidth = internalBuffer.getWidth();
				int imgHeight = internalBuffer.getHeight();
				
				int imgHalfWidth = imgWidth / 2;
				int imgHalfHeight = imgHeight / 2;
				
				if(temp.getWidth() != imgHalfWidth || temp.getHeight() != imgHalfHeight)
				{
					internalBuffer = new FloatImage(3, temp.getWidth() * 2, temp.getHeight() * 2);
					
					imgWidth = internalBuffer.getWidth();
					imgHeight = internalBuffer.getHeight();	
				}
				
				double[][] ored = internalBuffer.getChannelData(0);
				double[][] ogreen = internalBuffer.getChannelData(1);
				double[][] oblue = internalBuffer.getChannelData(2);
				
				double[][] ired = temp.getChannelData(0);
				double[][] igreen = temp.getChannelData(1);
				double[][] iblue = temp.getChannelData(2);
				
				double min;
				
				int id2, jd2;
				
				for(int i = 0; i < imgWidth; ++i)
				{
					for(int j = 0; j < imgHeight; ++j)
					{
						id2 = i / 2;
						jd2 = j / 2;
						
						ored[i][j] = ired[id2][jd2];
						ogreen[i][j] = igreen[id2][jd2];
						oblue[i][j] = iblue[id2][jd2];
					}
				}
			}
			needsProcessing = false;
		}
		
		return internalBuffer;
	}	
}